searchNodes=[{"doc":"The behaviour for precompiler modules.","ref":"ElixirMake.Precompiler.html","title":"ElixirMake.Precompiler","type":"behaviour"},{"doc":"This callback should return a list of triplets (&quot;arch-os-abi&quot;) for all supported targets of the given operation. For the :compile operation, all_supported_targets should return a list of targets that the current host is capable of (cross-)compiling to. For the :fetch operation, all_supported_targets should return the full list of targets. For example, GitHub Actions provides Linux, macOS and Windows CI hosts, when operation is :compile , the precompiler might return [&quot;x86_64-linux-gnu&quot;] if it is running in the Linux CI environment, while returning [&quot;x86_64-apple-darwin&quot;, &quot;aarch64-apple-darwin&quot;] on macOS, or [&quot;amd64-windows&quot;, &quot;x86-windows&quot;] on Windows platform. When operation is :fetch , the precompiler should return the full list. The full list for the above example should be: [ &quot;x86_64-linux-gnu&quot; , &quot;x86_64-apple-darwin&quot; , &quot;aarch64-apple-darwin&quot; , &quot;amd64-windows&quot; , &quot;x86-windows&quot; ] This allows the precompiler to do the compilation work in multilple hosts and gather all the artefacts later with mix elixir_make.checksum --all .","ref":"ElixirMake.Precompiler.html#c:all_supported_targets/1","title":"ElixirMake.Precompiler.all_supported_targets/1","type":"callback"},{"doc":"This callback will be invoked when the user executes the mix compile (or mix compile.elixir_make ) command. The precompiler should then compile the NIF library &quot;natively&quot;. Note that it is possible for the precompiler module to pick up other environment variables like TARGET_ARCH=aarch64 and adjust compile arguments correspondingly.","ref":"ElixirMake.Precompiler.html#c:build_native/1","title":"ElixirMake.Precompiler.build_native/1","type":"callback"},{"doc":"This callback should return the target triplet for current node.","ref":"ElixirMake.Precompiler.html#c:current_target/0","title":"ElixirMake.Precompiler.current_target/0","type":"callback"},{"doc":"Invoke the regular Mix toolchain compilation.","ref":"ElixirMake.Precompiler.html#mix_compile/1","title":"ElixirMake.Precompiler.mix_compile/1","type":"function"},{"doc":"Optional post actions to run after all precompilation tasks are done. It will only be called at the end of the mix elixir_make.precompile command. For example, actions can be archiving all precompiled artefacts and uploading the archive file to an object storage server.","ref":"ElixirMake.Precompiler.html#c:post_precompile/0","title":"ElixirMake.Precompiler.post_precompile/0","type":"callback"},{"doc":"This callback should precompile the library to the given target(s). Returns :ok if the requested target has successfully compiled.","ref":"ElixirMake.Precompiler.html#c:precompile/2","title":"ElixirMake.Precompiler.precompile/2","type":"callback"},{"doc":"Target triplet.","ref":"ElixirMake.Precompiler.html#t:target/0","title":"ElixirMake.Precompiler.target/0","type":"type"},{"doc":"Runs make in the current project. This task runs make in the current project; any output coming from make is printed in real-time on stdout. Configuration This compiler can be configured through the return value of the project/0 function in mix.exs ; for example: def project ( ) do [ app : :myapp , make_executable : &quot;make&quot; , make_makefile : &quot;Othermakefile&quot; , compilers : [ :elixir_make ] ++ Mix . compilers , deps : deps ( ) ] end The following options are available: :make_executable - (binary or :default ) it's the executable to use as the make program. If not provided or if :default , it defaults to &quot;nmake&quot; on Windows, &quot;gmake&quot; on FreeBSD, OpenBSD and NetBSD, and &quot;make&quot; on everything else. You can, for example, customize which executable to use on a specific OS and use :default for every other OS. If the MAKE environment variable is present, that is used as the value of this option. :make_makefile - (binary or :default ) it's the Makefile to use. Defaults to &quot;Makefile&quot; for Unix systems and &quot;Makefile.win&quot; for Windows systems if not provided or if :default . :make_targets - (list of binaries) it's the list of Make targets that should be run. Defaults to [] , meaning make will run the first target. :make_clean - (list of binaries) it's a list of Make targets to be run when mix clean is run. It's only run if a non- nil value for :make_clean is provided. Defaults to nil . :make_cwd - (binary) it's the directory where make will be run, relative to the root of the project. :make_env - (map of binary to binary) it's a map of extra environment variables to be passed to make . You can also pass a function in here in case make_env needs access to things that are not available during project setup; the function should return a map of binary to binary. Many default environment variables are set, see section below :make_error_message - (binary or :default ) it's a custom error message that can be used to give instructions as of how to fix the error (e.g., it can be used to suggest installing gcc if you're compiling a C dependency). :make_args - (list of binaries) it's a list of extra arguments to be passed. The following options configure precompilation: :make_precompiler - a two-element tuple with the precompiled type and module to use. The precompile type is either :nif or :port and then the precompilation module. If the type is a :nif , it looks for a DDL or a shared object as precompilation target given by :make_precompiler_filename and the current NIF version is part of the precompiled archive. If :port , it looks for an executable with :make_precompiler_filename . :make_precompiler_url - the download URL template. Defaults to none. Required when make_precompiler is set. :make_precompiler_filename - the filename of the compiled artefact without its extension. Defaults to the app name. :make_force_build - if build should be forced even if precompiled artefacts are available. Defaults to true if the app has a -dev version flag. See the Precompilation guide for more information. Default environment variables There are also several default environment variables set: MIX_TARGET MIX_ENV MIX_BUILD_PATH - same as Mix.Project.build_path/0 MIX_APP_PATH - same as Mix.Project.app_path/0 MIX_COMPILE_PATH - same as Mix.Project.compile_path/0 MIX_CONSOLIDATION_PATH - same as Mix.Project.consolidation_path/0 MIX_DEPS_PATH - same as Mix.Project.deps_path/0 MIX_MANIFEST_PATH - same as Mix.Project.manifest_path/0 ERL_EI_LIBDIR ERL_EI_INCLUDE_DIR ERTS_INCLUDE_DIR ERL_INTERFACE_LIB_DIR ERL_INTERFACE_INCLUDE_DIR These may also be overwritten with the make_env option. Compilation artifacts and working with priv directories Generally speaking, compilation artifacts are written to the priv directory, as that the only directory, besides ebin , which are available to Erlang/OTP applications. However, note that Mix projects supports the :build_embedded configuration, which controls if assets in the _build directory are symlinked (when false , the default) or copied ( true ). In order to support both options for :build_embedded , it is important to follow the given guidelines: The &quot;priv&quot; directory must not exist in the source code The Makefile should copy any artifact to $MIX_APP_PATH/priv or, even better, to $MIX_APP_PATH/priv/$MIX_TARGET If there are static assets, the Makefile should copy them over from a directory at the project root (not named &quot;priv&quot;)","ref":"Mix.Tasks.Compile.ElixirMake.html","title":"Mix.Tasks.Compile.ElixirMake","type":"task"},{"doc":"A task responsible for downloading the precompiled NIFs for a given module. This task must only be used by package creators who want to ship the precompiled NIFs. The goal is to download the precompiled packages and generate a checksum to check-in alongside the project in the the Hex repository. This is done by passing the --all flag. You can also use the --only-local flag to download only the precompiled package for use during development. You can use the --ignore-unavailable flag to ignore any NIFs that are not available. This is useful when you are developing a new NIF that does not support all platforms. This task also accept the --print flag to print the checksums.","ref":"Mix.Tasks.ElixirMake.Checksum.html","title":"Mix.Tasks.ElixirMake.Checksum","type":"task"},{"doc":"Precompiles the given project for all targets. This task must only be used by package creators who want to ship the precompiled NIFs. This task is often used on CI to precompile for different targets. This is only supported if :make_precompiler is specified in your project configuration.","ref":"Mix.Tasks.ElixirMake.Precompile.html","title":"Mix.Tasks.ElixirMake.Precompile","type":"task"},{"doc":"This guide has two sections, the first one is intended for precompiler module developers. It covers a minimal example of creating a precompiler module. The second section is intended for library developers who want their library to be able to use precompiled artefacts in a simple way. Library Developer Precompiler Module Developer","ref":"precompilation_guide.html","title":"Precompilation guide","type":"extras"},{"doc":"This guide assumes you have already added elixir_make to your library and you have written a Makefile that compiles the native code in your project. Once your native code compile and works as expected, you are now ready to precompile it. A full demo project is available on cocoa-xu/cc_precompiler_example . Setup mix.exs To use a precompiler module such as the CCPrecompiler example above, we first add the precompiler ( :cc_precompiler here) and :elixir_make to deps . def deps do [ # ... { :elixir_make , &quot;~&gt; 0.6&quot; , runtime : false } , { :cc_precompiler , &quot;~&gt; 0.1.0&quot; , runtime : false , github : &quot;cocoa-xu/cc_precompiler&quot; } # ... ] end Then add :elixir_make to the compilers list, and set the type ( :nif or :port ) and CCPrecompile as the value for :make_precompiler . @version &quot;0.1.0&quot; def project do [ # ... compilers : [ :elixir_make ] ++ Mix . compilers ( ) , # elixir_make specific config make_precompiler : { :nif , CCPrecompiler } , make_precompiler_url : &quot;https://github.com/cocoa-xu/cc_precompiler_example/releases/download/v \#{ @version } /@{artefact_filename}&quot; , make_precompiler_filename : &quot;nif&quot; , make_precompiler_priv_paths : [ &quot;nif.*&quot; ] # ... ] end Another required field is make_precompiler_url . It is a URL template to the artefact file. @{artefact_filename} in the URL template string will be replaced by corresponding artefact filenames when fetching them. For example, cc_precompiler_example-nif-2.16-x86_64-linux-gnu-0.1.0.tar.gz . Note that there is an optional config key for elixir_make, make_precompiler_filename . If the name (file extension does not count) of the shared library is different from your app's name, then make_precompiler_filename should be set. For example, if the app name is &quot;cc_precompiler_example&quot; while the name shared library is &quot;nif.so&quot; (or &quot;nif.dll&quot; on windows), then make_precompiler_filename should be set as &quot;nif&quot; . Another optional config key is make_precompiler_priv_paths . For example, say the priv directory is organised as follows in Linux, macOS and Windows respectively, # Linux . ├ ─ ─ assets │ ├ ─ ─ model . onnx │ └ ─ ─ data . json ├ ─ ─ lib │ ├ ─ ─ libpriv1 . so │ ├ ─ ─ libpriv2 . so │ └ ─ ─ libpriv3 . so └ ─ ─ nif . so # macOS . ├ ─ ─ assets │ ├ ─ ─ model . onnx │ └ ─ ─ data . json ├ ─ ─ lib │ ├ ─ ─ libpriv1 . dylib │ ├ ─ ─ libpriv2 . dylib │ └ ─ ─ libpriv3 . dylib └ ─ ─ nif . so # Windows . ├ ─ ─ assets │ ├ ─ ─ model . onnx │ └ ─ ─ data . json ├ ─ ─ lib │ ├ ─ ─ libpriv1 . dll │ ├ ─ ─ libpriv2 . dll │ └ ─ ─ libpriv3 . dll └ ─ ─ nif . dll By default, everything in priv will be included in the precompiled tar file. However, files in assets can be very large or platform-independent, therefore, we would like to only include the nif.so ( nif.dll ) file and everything in the lib directory in the precompiled tar file to reduce the footprint. In this case, we can set make_precompiler_priv_paths to [&quot;nif.so&quot;, &quot;nif.dll&quot;, &quot;lib&quot;] . Of course, wildcards ( ? , ** , * ) are supported when specifiying files. For example, [&quot;nif.*&quot;, &quot;lib/*.so&quot;, &quot;lib/*.dll&quot;, &quot;lib/*.dylib&quot;] will include nif.so (Linux/macOS) or nif.dll (Windows), and .so or .dll files in the lib directory. Directory structures and symbolic links are preserved. (Optional) Customise Precompilation Targets To override the default configuration, please set the cc_precompile key in project . For example, def project do [ # ... cc_precompile : [ # optional config that provides a map of available compilers # on different systems compilers : %{ # key (`:os.type()`) # this allows us to provide different available targets # on different systems # value is a map that describes which compilers are available # # key == {:unix, :linux} =&gt; when compiling on Linux { :unix , :linux } =&gt; %{ # key (target triplet) =&gt; `riscv64-linux-gnu` # value =&gt; `PREFIX` # - for strings, the string will be used as the prefix of # the C and C++ compiler respectively, i.e., # CC=`\#{prefix}gcc` # CXX=`\#{prefix}g++` &quot;riscv64-linux-gnu&quot; =&gt; &quot;riscv64-linux-gnu-&quot; , # key (target triplet) =&gt; `armv7l-linux-gnueabihf` # value =&gt; `{CC, CXX}` # - for 2-tuples, the elements are the executable name of # the C and C++ compiler respectively &quot;armv7l-linux-gnueabihf&quot; =&gt; { &quot;arm-linux-gnueabihf-gcc&quot; , &quot;arm-linux-gnueabihf-g++&quot; } , # key (target triplet) =&gt; `armv7l-linux-gnueabihf` # value =&gt; `{CC_EXECUTABLE, CXX_EXECUTABLE, CC_TEMPLATE, CXX_TEMPLATE}` # # - for 4-tuples, the first two elements are the same as in # 2-tuple, the third and fourth elements are the template # string for CC and CPP/CXX. for example, # # the last entry below shows the example of using zig as the # crosscompiler for `aarch64-linux-musl`, # the &quot;CC&quot; will be # &quot;zig cc -target aarch64-linux-musl&quot;, # and &quot;CXX&quot; and &quot;CPP&quot; will be # &quot;zig c++ -target aarch64-linux-musl&quot; &quot;aarch64-linux-musl&quot; =&gt; { &quot;zig&quot; , &quot;zig&quot; , &quot;&lt;% cc %&gt; cc -target aarch64-linux-musl&quot; , &quot;&lt;% cxx %&gt; c++ -target aarch64-linux-musl&quot; } } , # key == {:unix, :darwin} =&gt; when compiling on macOS { :unix , :darwin } =&gt; %{ # key (target triplet) =&gt; `aarch64-apple-darwin` # value =&gt; `{CC, CXX}` &quot;aarch64-apple-darwin&quot; =&gt; { &quot;gcc -arch arm64&quot; , &quot;g++ -arch arm64&quot; } , # key (target triplet) =&gt; `aarch64-linux-musl` # value =&gt; `{CC_EXECUTABLE, CXX_EXECUTABLE, CC_TEMPLATE, CXX_TEMPLATE}` &quot;aarch64-linux-musl&quot; =&gt; { &quot;zig&quot; , &quot;zig&quot; , &quot;&lt;% cc %&gt; cc -target aarch64-linux-musl&quot; , &quot;&lt;% cxx %&gt; c++ -target aarch64-linux-musl&quot; } } } ] ] (Optional) Test the NIF code locally To test the NIF code locally, you can either set force_build to true or append &quot;-dev&quot; to your NIF library's version string. @version &quot;0.1.0-dev&quot; def project do [ # either append `&quot;-dev&quot;` to your NIF library&#39;s version string version : @version , # or set force_build to true make_force_build : true , # ... ] end Doing so will ask elixir_make to only compile for the current host instead of building for all available targets. $ mix compile cc -shared -std=c11 -O3 -fPIC -I&quot;/usr/local/lib/erlang/erts-13.0.3/include&quot; -undefined dynamic_lookup -flat_namespace -undefined suppress &quot;/Users/cocoa/git/cc_precompiler_example/c_src/cc_precompiler_example.c&quot; -o &quot;/Users/cocoa/Git/cc_precompiler_example/_build/dev/lib/cc_precompiler_example/priv/nif.so&quot; $ mix test make: Nothing to be done for `build&#39;. Generated cc_precompiler_example app . Finished in 0.00 seconds (0.00s async, 0.00s sync) 1 test, 0 failures Randomized with seed 102464 Precompile for available targets It's possible to either setup a CI task to do the precompilation job or precompile on a local machine and upload the precompiled artefacts. To precompile for all targets on a local machine: MIX_ENV=prod mix elixir_make.precompile Environment variable ELIXIR_MAKE_CACHE_DIR can be used to set the cache dir for the precompiled artefacts, for instance, to output precompiled artefacts in the cache directory of the current working directory, export ELIXIR_MAKE_CACHE_DIR=&quot;$(pwd)/cache&quot; . To setup a CI task such as GitHub Actions, the following workflow file can be used for reference: name: precompile on: push: tags: - 'v*' jobs: linux: runs-on: ubuntu-latest env: MIX_ENV: &quot;prod&quot; steps: - uses: actions/checkout@v3 - uses: erlef/setup-beam@v1 with: otp-version: &quot;25.0.2&quot; elixir-version: &quot;1.13.4&quot; - name: Install system dependecies run: | sudo apt-get update sudo apt-get install -y build-essential automake autoconf pkg-config bc m4 unzip zip \\ gcc-aarch64-linux-gnu g++-aarch64-linux-gnu \\ gcc-riscv64-linux-gnu g++-riscv64-linux-gnu - name: Mix Test run: | mix deps.get MIX_ENV=test mix test - name: Create precompiled library run: | export ELIXIR_MAKE_CACHE_DIR=$(pwd)/cache mkdir -p &quot;${ELIXIR_MAKE_CACHE_DIR}&quot; mix elixir_make.precompile - uses: softprops/action-gh-release@v1 if: startsWith(github.ref, 'refs/tags/') with: files: | cache/*.tar.gz macos: runs-on: macos-11 env: MIX_ENV: &quot;prod&quot; steps: - uses: actions/checkout@v3 - name: Install erlang and elixir run: | brew install erlang elixir mix local.hex --force mix local.rebar --force - name: Mix Test run: | mix deps.get MIX_ENV=test mix test - name: Create precompiled library run: | export ELIXIR_MAKE_CACHE_DIR=$(pwd)/cache mkdir -p &quot;${ELIXIR_MAKE_CACHE_DIR}&quot; mix elixir_make.precompile - uses: softprops/action-gh-release@v1 if: startsWith(github.ref, 'refs/tags/') with: files: | cache/*.tar.gz Generate checksum file After CI has finished, you can fetch the precompiled binaries from GitHub. $ MIX_ENV=prod mix elixir_make.checksum --all --ignore-unavailable Meanwhile, a checksum file will be generated. In this example, the checksum file will be named as checksum-cc_precompiler_example.exs in current working directory. This checksum file is extremely important in the scenario where you need to release a Hex package using precompiled NIFs. It's MANDATORY to include this file in your Hex package (by updating the files field in the mix.exs ). Otherwise your package won't work . defp package do [ files : [ &quot;lib&quot; , &quot;checksum.exs&quot; , &quot;mix.exs&quot; , # ... ] , # ... ] end However, there is no need to track the checksum file in your version control system (git or other), so consider adding it to your .gitignore . (Optional) Test fetched artefacts can work locally # delete previously built binaries so that # elixir_make will try to restore the NIF library # from the downloaded tarball file $ rm -rf _build/prod/lib/cc_precompiler_example # set to prod env and test everything $ MIX_ENV=prod mix test ==&gt; castore Compiling 1 file (.ex) Generated castore app ==&gt; elixir_make Compiling 5 files (.ex) Generated elixir_make app ==&gt; cc_precompiler Compiling 1 file (.ex) Generated cc_precompiler app 20:47:42.262 [debug] Restore NIF for current node from: /Users/cocoa/Library/Caches/cc_precompiler_example-nif-2.16-aarch64-apple-darwin-0.1.0.tar.gz ==&gt; cc_precompiler_example Compiling 1 file (.ex) Generated cc_precompiler_example app . Finished in 0.01 seconds (0.00s async, 0.01s sync) 1 test, 0 failures Randomized with seed 539590 Recommended flow To recap, the suggested flow is the following: Choose an appropriate precompiler for your NIF library and set all necessary options in the mix.exs . (Optional) Test if your NIF library compiles locally. mix compile mix test (Optional) Test if your NIF library can precompile to all specified targets locally. MIX_ENV=prod mix elixir_make.precompile Precompile your library on CI or locally. # locally MIX_ENV=prod mix elixir_make.precompile # CI # please see the docs above Fetch precompiled binaries from GitHub. # only fetch artefact for current host MIX_ENV=prod mix elixir_make.checksum --only-local --print # fetch all MIX_ENV=prod mix elixir_make.checksum --all --print # to fetch all available artefacts at the moment MIX_ENV=prod mix elixir_make.checksum --all --print --ignore-unavailable (Optional) Test if the downloaded artefacts works as expected. rm -rf _build/prod/lib/NIF_LIBRARY_NAME MIX_ENV=prod mix test Update Hex package to include the checksum file. Release the package to Hex.pm (make sure your release includes the correct files).","ref":"precompilation_guide.html#library-developer","title":"Precompilation guide - Library Developer","type":"extras"},{"doc":"In this section, I'll walk you through creating a simple precompiler that utilises existing crosscompilers in the system. Create a new precompiler module We start by creating a new elixir library, say cc_precompiler . $ mix new cc_precompiler * creating README.md * creating .formatter.exs * creating .gitignore * creating mix.exs * creating lib * creating lib/cc_precompiler.ex * creating test * creating test/test_helper.exs * creating test/cc_precompiler_test.exs Your Mix project was created successfully. You can use &quot;mix&quot; to compile it, test it, and more: cd cc_precompiler mix test Run &quot;mix help&quot; for more commands. Then in the mix.exs file, we add :elixir_make to deps . defp deps do [ { :elixir_make , &quot;~&gt; 0.6&quot; , runtime : false } ] end Write the CC Precompiler To create a precompiler module that is compatible with elixir_make , the module ( lib/cc_precompiler.ex ) need to implement a few callbacks defined in the ElixirMake.Precompiler beheviour. The full project of cc_precompiler is available on cocoa-xu/cc_precompiler . defmodule CCPrecompiler do @moduledoc &quot;&quot;&quot; Precompile with existing crosscompiler in the system. &quot;&quot;&quot; require Logger @behaviour ElixirMake.Precompiler # This is the default configuration for this demo precompiler module # for linux systems, it will detect for the following targets # - x86_64-linux-gnu # - i686-linux-gnu # - aarch64-linux-gnu # - armv7l-linux-gnueabihf # - riscv64-linux-gnu # - powerpc64le-linux-gnu # - s390x-linux-gnu # by trying to find the corresponding executable, i.e., # - x86_64-linux-gnu-gcc # - i686-linux-gnu-gcc # - aarch64-linux-gnu-gcc # - arm-linux-gnueabihf-gcc # - riscv64-linux-gnu-gcc # - powerpc64le-linux-gnu-gcc # - s390x-linux-gnu-gcc # (this module will only try to find the CC executable, a step further # will be trying to compile a simple C/C++ program using them) @default_compilers %{ { :unix , :linux } =&gt; %{ &quot;x86_64-linux-gnu&quot; =&gt; &quot;x86_64-linux-gnu-&quot; , &quot;i686-linux-gnu&quot; =&gt; &quot;i686-linux-gnu-&quot; , &quot;aarch64-linux-gnu&quot; =&gt; &quot;aarch64-linux-gnu-&quot; , &quot;armv7l-linux-gnueabihf&quot; =&gt; &quot;arm-linux-gnueabihf-&quot; , &quot;riscv64-linux-gnu&quot; =&gt; &quot;riscv64-linux-gnu-&quot; , &quot;powerpc64le-linux-gnu&quot; =&gt; &quot;powerpc64le-linux-gnu-&quot; , &quot;s390x-linux-gnu&quot; =&gt; &quot;s390x-linux-gnu-&quot; } , { :unix , :darwin } =&gt; %{ &quot;x86_64-apple-darwin&quot; =&gt; { &quot;gcc&quot; , &quot;g++&quot; , &quot;&lt;%= cc %&gt; -arch x86_64&quot; , &quot;&lt;%= cxx %&gt; -arch x86_64&quot; } , &quot;aarch64-apple-darwin&quot; =&gt; { &quot;gcc&quot; , &quot;g++&quot; , &quot;&lt;%= cc %&gt; -arch arm64&quot; , &quot;&lt;%= cxx %&gt; -arch arm64&quot; } } , { :win32 , :nt } =&gt; %{ &quot;x86_64-windows-msvc&quot; =&gt; { &quot;cl&quot; , &quot;cl&quot; } } } defp default_compilers , do : @default_compilers defp user_config , do : Mix.Project . config ( ) [ :cc_precompile ] || default_compilers ( ) defp compilers , do : Access . get ( user_config ( ) , :compilers , default_compilers ( ) ) defp compilers_current_os , do : Access . get ( compilers ( ) , :os . type ( ) , %{ } ) @impl ElixirMake.Precompiler def current_target do current_target_from_env = current_target_from_env ( ) if current_target_from_env do # overwrite current target triplet { :ok , current_target_from_env } else current_target ( :os . type ( ) ) end end defp current_target_from_env do arch = System . get_env ( &quot;TARGET_ARCH&quot; ) os = System . get_env ( &quot;TARGET_OS&quot; ) abi = System . get_env ( &quot;TARGET_ABI&quot; ) if ! Enum . all? ( [ arch , os , abi ] , &amp; Kernel . is_nil / 1 ) do &quot; \#{ arch } - \#{ os } - \#{ abi } &quot; end end def current_target ( { :win32 , _ } ) do processor_architecture = String . downcase ( String . trim ( System . get_env ( &quot;PROCESSOR_ARCHITECTURE&quot; ) ) ) # https://docs.microsoft.com/en-gb/windows/win32/winprog64/wow64-implementation-details?redirectedfrom=MSDN partial_triplet = case processor_architecture do &quot;amd64&quot; -&gt; &quot;x86_64-windows-&quot; &quot;ia64&quot; -&gt; &quot;ia64-windows-&quot; &quot;arm64&quot; -&gt; &quot;aarch64-windows-&quot; &quot;x86&quot; -&gt; &quot;x86-windows-&quot; end { compiler , _ } = :erlang . system_info ( :c_compiler_used ) case compiler do :msc -&gt; { :ok , partial_triplet &lt;&gt; &quot;msvc&quot; } :gnuc -&gt; { :ok , partial_triplet &lt;&gt; &quot;gnu&quot; } other -&gt; { :ok , partial_triplet &lt;&gt; Atom . to_string ( other ) } end end def current_target ( { :unix , _ } ) do # get current target triplet from `:erlang.system_info/1` system_architecture = to_string ( :erlang . system_info ( :system_architecture ) ) current = String . split ( system_architecture , &quot;-&quot; , trim : true ) case length ( current ) do 4 -&gt; { :ok , &quot; \#{ Enum . at ( current , 0 ) } - \#{ Enum . at ( current , 2 ) } - \#{ Enum . at ( current , 3 ) } &quot; } 3 -&gt; case :os . type ( ) do { :unix , :darwin } -&gt; # could be something like aarch64-apple-darwin21.0.0 # but we don&#39;t really need the last 21.0.0 part if String . match? ( Enum . at ( current , 2 ) , ~r/^darwin.*/ ) do { :ok , &quot; \#{ Enum . at ( current , 0 ) } - \#{ Enum . at ( current , 1 ) } -darwin&quot; } else { :ok , system_architecture } end _ -&gt; { :ok , system_architecture } end _ -&gt; { :error , &quot;cannot decide current target&quot; } end end @impl ElixirMake.Precompiler def all_supported_targets ( :compile ) do # This callback is expected to return a list of string for # all supported targets by this precompiler. in this # implementation, we will try to find a few crosscompilers # available in the system. # # Note that this implementation is mainly used for demostration # purpose, therefore the hardcoded compiler names are used in # DEBIAN/Ubuntu Linux (as I only installed these ones at the # time of writting this example) with { :ok , current } &lt;- current_target ( ) do Enum . uniq ( [ current ] ++ find_all_available_targets ( ) ) else _ -&gt; [ ] end end @impl ElixirMake.Precompiler def all_supported_targets ( :fetch ) do Enum . flat_map ( compilers ( ) , &amp; Map . keys ( elem ( &amp;1 , 1 ) ) ) end defp find_all_available_targets do Map . keys ( compilers_current_os ( ) ) |&gt; Enum . map ( &amp; find_available_compilers ( &amp;1 , Map . get ( compilers_current_os ( ) , &amp;1 ) ) ) |&gt; Enum . reject ( &amp; is_nil / 1 ) end defp find_available_compilers ( triplet , compilers ) when is_tuple ( compilers ) do if System . find_executable ( elem ( compilers , 0 ) ) do Logger . debug ( &quot;Found compiler for \#{ triplet } &quot; ) triplet else Logger . debug ( &quot;Compiler not found for \#{ triplet } &quot; ) nil end end defp find_available_compilers ( triplet , invalid ) do Mix . raise ( &quot;Invalid configuration for \#{ triplet } , expecting a 2-tuple or 4-tuple, however, got \#{ inspect ( invalid ) } &quot; ) end @impl ElixirMake.Precompiler def build_native ( args ) do # In this callback we just build the NIF library natively, # and because this precompiler module is designed for NIF # libraries that use C/C++ as the main language with Makefile, # we can just call `ElixirMake.Precompiler.mix_compile(args)` # # It&#39;s also possible to forward this call to: # # precompile(args, elem(current_target(), 1)) # # This could be useful when the precompiler is using a universal # (cross-)compiler, say zig. in this way, the compiled binaries # (`mix compile`) will be consistent as the corrsponding precompiled # one (with `mix elixir_make.precompile`) # # However, if you&#39;d prefer to having the same behaviour for `mix compile` # then the following line is okay ElixirMake.Precompiler . mix_compile ( args ) end @impl ElixirMake.Precompiler def precompile ( args , target ) do # Potentially clean the output directory to avoid conflicts File . rm! ( Path . join ( Mix.Project . app_path ( ) , &quot;priv&quot; ) ) saved_cc = System . get_env ( &quot;CC&quot; ) || &quot;&quot; saved_cxx = System . get_env ( &quot;CXX&quot; ) || &quot;&quot; saved_cpp = System . get_env ( &quot;CPP&quot; ) || &quot;&quot; Logger . debug ( &quot;Current compiling target: \#{ target } &quot; ) { cc , cxx } = get_cc_and_cxx ( target ) System . put_env ( &quot;CC&quot; , cc ) System . put_env ( &quot;CXX&quot; , cxx ) System . put_env ( &quot;CPP&quot; , cxx ) ElixirMake.Precompiler . mix_compile ( args ) System . put_env ( &quot;CC&quot; , saved_cc ) System . put_env ( &quot;CXX&quot; , saved_cxx ) System . put_env ( &quot;CPP&quot; , saved_cpp ) :ok end defp get_cc_and_cxx ( triplet ) do case Access . get ( compilers_current_os ( ) , triplet , nil ) do nil -&gt; cc = System . get_env ( &quot;CC&quot; ) cxx = System . get_env ( &quot;CXX&quot; ) cpp = System . get_env ( &quot;CPP&quot; ) case { cc , cxx , cpp } do { nil , _ , _ } -&gt; { &quot;gcc&quot; , &quot;g++&quot; } { _ , nil , nil } -&gt; { &quot;gcc&quot; , &quot;g++&quot; } { _ , _ , nil } -&gt; { cc , cxx } { _ , nil , _ } -&gt; { cc , cpp } { _ , _ , _ } -&gt; { cc , cxx } end { cc , cxx } -&gt; { cc , cxx } prefix when is_binary ( prefix ) -&gt; { &quot; \#{ prefix } gcc&quot; , &quot; \#{ prefix } g++&quot; } { cc , cxx , cc_args , cxx_args } -&gt; { &quot; \#{ cc } \#{ cc_args } &quot; , &quot; \#{ cxx } \#{ cxx_args } &quot; } end end @impl ElixirMake.Precompiler def post_precompile ( ) do # It&#39;s possible to do some post precompilation work # in this optionall callback # after all precompile targets are compiled. Logger . debug ( &quot;Post precompile&quot; ) end end","ref":"precompilation_guide.html#precompiler-module-developer","title":"Precompilation guide - Precompiler Module Developer","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Use CACerts from Erlang/OTP 25 if available","ref":"changelog.html#v0-7-1-2022-12-07","title":"Changelog - v0.7.1 (2022-12-07)","type":"extras"},{"doc":"Support precompilation with custom precompilers Don't pass default Erlang environment variables into make","ref":"changelog.html#v0-7-0-2022-12-02","title":"Changelog - v0.7.0 (2022-12-02)","type":"extras"},{"doc":"Fallback to make if nmake is not available on Windows.","ref":"changelog.html#v0-6-3-2021-10-19","title":"Changelog - v0.6.3 (2021-10-19)","type":"extras"},{"doc":"Fix permissions for some files in the repository.","ref":"changelog.html#v0-6-2-2020-12-03","title":"Changelog - v0.6.2 (2020-12-03)","type":"extras"},{"doc":"Warn on paths that contain spaces. Use gmake on NetBSD.","ref":"changelog.html#v0-6-1-2020-09-07","title":"Changelog - v0.6.1 (2020-09-07)","type":"extras"},{"doc":"Start tracking CHANGELOG.","ref":"changelog.html#v0-6-0-2019-06-10","title":"Changelog - v0.6.0 (2019-06-10)","type":"extras"}]